#ifndef ROUND_H_
#define ROUND_H_

#include "ascon.h"
#include "printstate.h"

__forceinline void KINIT(word_t* K0, word_t* K1, word_t* K2) {
  *K0 = WORD_T(0);
  *K1 = WORD_T(0);
  *K2 = WORD_T(0);
}

__forceinline void PINIT(state_t* s) {
  s->x0 = WORD_T(0);
  s->x1 = WORD_T(0);
  s->x2 = WORD_T(0);
  s->x3 = WORD_T(0);
  s->x4 = WORD_T(0);
}

__forceinline void ROUND(state_t* s, uint32_t C_e, uint32_t C_o) {
  word_t tmp, C = {.o = C_o, .e = C_e};
  /* round constant */
  s->x2 = XOR(s->x2, C);
  /* s-box layer */
  s->x0 = XOR(s->x0, s->x4);
  s->x4 = XOR(s->x4, s->x3);
  s->x2 = XOR(s->x2, s->x1);
  tmp = AND(s->x0, NOT(s->x4));
  s->x0 = XOR(s->x0, AND(s->x2, NOT(s->x1)));
  s->x2 = XOR(s->x2, AND(s->x4, NOT(s->x3)));
  s->x4 = XOR(s->x4, AND(s->x1, NOT(s->x0)));
  s->x1 = XOR(s->x1, AND(s->x3, NOT(s->x2)));
  s->x3 = XOR(s->x3, tmp);
  s->x1 = XOR(s->x1, s->x0);
  s->x3 = XOR(s->x3, s->x2);
  s->x0 = XOR(s->x0, s->x4);
  /* linear layer */
  tmp = XOR(s->x0, ROR64(s->x0, 28 - 19));
  s->x0 = XOR(s->x0, ROR64(tmp, 19));
  tmp = XOR(s->x1, ROR64(s->x1, 61 - 39));
  s->x1 = XOR(s->x1, ROR64(tmp, 39));
  tmp = XOR(s->x2, ROR64(s->x2, 6 - 1));
  s->x2 = XOR(s->x2, ROR64(tmp, 1));
  tmp = XOR(s->x3, ROR64(s->x3, 17 - 10));
  s->x3 = XOR(s->x3, ROR64(tmp, 10));
  tmp = XOR(s->x4, ROR64(s->x4, 41 - 7));
  s->x4 = XOR(s->x4, ROR64(tmp, 7));
  s->x2 = NOT(s->x2);
  printstate(" round output", s);
}

#endif /* ROUND_H_ */
